package Filesystem;

public class FileI extends _FileDisp implements NodeI
{
    public
    FileI(String name, DirectoryI parent)
    {
        _name = name;
        _parent = parent;
        _myID = java.util.UUID.randomUUID().toString();
        _rand = new java.util.Random();
    }

    public String
    id()
    {
        return _myID;
    }

    public void
    activate(Ice.ObjectAdapter adapter)
    {
        Ice.Identity id = new Ice.Identity();
        id.name = _myID;
        adapter.add(this, id);
        if(_parent != null)
        {
            _parent.addChild(_name, this);
        }
    }

    public String
    name(Ice.Current c)
    {
        return _name;
    }

    public String[]
    read(Ice.Current c)
        throws IOError
    {
        if(_rand.nextInt(4) == 0)
        {
            throw new IOError("could not read file");
        }
        return _lines;
    }

    public void
    write(String[] text, Ice.Current c)
        throws IOError
    {
        _lines = text;
    }

    private String _name;
    private DirectoryI _parent;
    private String _myID;
    private java.util.Random _rand;
    private String[] _lines;
}
