module Filesystem
{
    exception IOError
    {
        string reason;
    };

    interface Node
    {
        idempotent string name();
        idempotent int size();
    };

    sequence<string> Lines;

    interface File extends Node
    {
        idempotent Lines read() throws IOError;
        idempotent void write(Lines text) throws IOError;
    };

    enum NodeType { FileT, DirT };

    struct NodeDetails
    {
        string name;
        NodeType type;
        Node* proxy;
    };

    sequence<NodeDetails> NodeDetailsSeq;

    interface Directory extends Node
    {
        idempotent NodeDetailsSeq list();
    };
};
