package Filesystem;

public class FileI extends _FileDisp implements NodeI
{
    public
    FileI(String name, DirectoryI parent)
    {
        _name = name;
        _parent = parent;
        _myID = java.util.UUID.randomUUID().toString();
    }

    public String
    id()
    {
        return _myID;
    }

    public void
    activate(Ice.ObjectAdapter adapter)
    {
        Ice.Identity id = new Ice.Identity();
        id.name = _myID;
        adapter.add(this, id);
        if(_parent != null)
        {
            _parent.addChild(_name, this);
        }
    }

    public String
    name(Ice.Current c)
    {
        return _name;
    }

    public int
    size(Ice.Current c)
    {
        int sz = 0;
        for(int i = 0; i < _lines.length; ++i)
        {
            sz += _lines[i].length();
        }
       return sz;
    }

    public String[]
    read(Ice.Current c)
        throws IOError
    {
        return _lines;
    }

    public void
    write(String[] text, Ice.Current c)
        throws IOError
    {
        _lines = text;
    }

    private String _name;
    private DirectoryI _parent;
    private String _myID;
    private String[] _lines;
}
