import Filesystem.*;

public class Client extends Ice.Application
{
    public int run(String[] args)
    {
        // Create a proxy for the root directory
        //
        Ice.ObjectPrx base = communicator().stringToProxy("RootDir:default -p 10000");

        // Down-cast the proxy to a Directory proxy
        //
        DirectoryPrx rootDir = DirectoryPrxHelper.checkedCast(base);
        if(rootDir == null)
            throw new RuntimeException("Invalid proxy");

        Thread[] threads = new Thread[3];
        for(int i = 0; i < threads.length; ++i)
        {
            threads[i] = new ListThread(rootDir, "thread " + i);
            threads[i].start();
            System.out.println("Started " + threads[i].getName());
        }

        for(int i = 0; i < threads.length; ++i)
        {
            System.out.println("Joining with " + threads[i].getName());
            while(true)
            {
                try
                {
                    threads[i].join();
                    break;
                }
                catch(InterruptedException ex)
                {
                    // Ignored
                }
            }
            System.out.println("Joined with " + threads[i].getName());
        }
        return 0;
    }

    public static void
    main(String[] args)
    {
        Client app = new Client();
        int status = app.main("Client", args);
        System.exit(status);
    }
}
