module Filesystem
{
    exception IOError
    {
	string reason;
    };
    
    exception NameInUse
    {
    };

    exception DirNotEmpty
    {
    };

    interface Node
    {
	idempotent string name();
	void destroy() throws DirNotEmpty;
    };

    sequence<string> Lines;

    interface File extends Node
    {
	idempotent Lines read() throws IOError;
	idempotent void write(Lines text) throws IOError;
    };

    enum NodeType { FileT, DirT };

    struct NodeDetails
    {
	string name;
	NodeType type;
	Node* proxy;
    };

    sequence<NodeDetails> NodeDetailsSeq;

    interface Directory extends Node
    {
	File* createFile(string name) throws NameInUse;
	Directory* createDir(string name) throws NameInUse;
	idempotent NodeDetailsSeq list();
    };
};
