import Filesystem.*;

public class Server extends Ice.Application
{
    public int
    run(String[] args)
    {
        // Shut down cleanly on interrupt.
        //
        shutdownOnInterrupt();

        Ice.ObjectAdapter adapter = communicator().createObjectAdapter("Lab8");

        // Create the root directory.
        //
        DirectoryI.makeRootDir(adapter);

        // All objects are created, allow client requests now.
        //
        adapter.activate();

        // Wait until we are done.
        //
        communicator().waitForShutdown();
        if(interrupted())
        {
            System.out.println(appName() + ": received signal, shutting down");
        }

        return 0;
    }

    public static void
    main(String[] args)
    {
        Server app = new Server();
        int status = app.main("Server", args);
        System.exit(status);
    }
}
